/**
 * Created by Administrator on 2014/12/14.
 */

function Boss1() {
    base(this, LSprite, []);

    var self = this;

    var list = LGlobal.divideCoordinate(360, 60, 1, 9)
    var data = new LBitmapData(_imgList["boss1"], 0, 0, 40, 60);
    self.animeRun = new LAnimation(self, data, [
        [list[0][0], list[0][1], list[0][2], list[0][3]],
        [list[0][4], list[0][5], list[0][6], list[0][7]],
        [list[0][8]]
    ]);

    self.hp = 10;
    self.canHited = false;
    self.reachPos = false;
    self.reachCount = 0;
    self.bulletIndex = 0;
    self.canShoot = true;
    self.shootCount = 0;
    self.shootInterval = 0;
    self.animeRun.setAction(1);
    self.direction = 1;
    self.moveCount = 0;
    self.bossMoveSpeed = 3;
    self.count = 0;
    self.deadCount = 0;
}

Boss1.prototype.onframe = function () {

    var self = this;

    if(self.reachCount == 20) {
        self.reachPos = true;
        //self.animeRun.setAction(0);
    }

    if(self.reachPos == false) {
        self.y += 10;
        self.reachCount++;
    }

    if(self.reachPos == true && self.hp > 0) {
        self.shoot();
        self.move();
    }

    if(self.canHited == true) {
        for(var i = 0; i < _bulletArr.length; i++) {

            if(hitEnermy(self, _bulletArr[i])) {
                //alert("hit");
                _bulletLayer.removeChild(_bulletArr[i]);
                _bulletArr.splice(i, 1);
                self.hp--;
                _woodWav.play();
            }
        }
    }

    if(self.count == 2) {
        self.animeRun.onframe();
        self.count = 0;
    }
    self.count++;

    if(self.hp <= 0) {
        //_backLayer.removeChild(self);
        //_boss1 = null;
        self.animeRun.setAction(2);
        self.deadCount++;
    }

    if(self.deadCount == 40) {
        _backLayer.removeChild(self);
        _boss1 = null;
        _shareType = 2;
        _backSound.stop();
        restart();
    }

}

Boss1.prototype.shoot = function () {

    var self = this;

    if(self.canShoot == true && self.shootInterval == 5) {
        self.shootInterval = 0;
        var bullet = new Bullet();
        bullet.x = self.x + 11;
        bullet.y = self.y + 48;

        bullet.enemy1XSpeed = - 6 + 3 * self.bulletIndex;
        bullet.enemy1YSpeed = 8;

        self.bulletIndex++;

        _enemy1BulletArr.push(bullet);
        _enermyBulletLayer.addChild(bullet);
    }

    if(self.canShoot == true) {
        self.shootInterval++;
    }

    if(self.bulletIndex == 5) {
        self.bulletIndex = 0;
        self.canShoot = false;
        self.animeRun.setAction(1);
        self.canHited = false;
    }

    self.shootCount++;

    if(self.shootCount == 60) {
        self.shootCount = 0;
        self.canShoot = true;
        self.animeRun.setAction(0);
        self.canHited = true;
    }

}

Boss1.prototype.move = function () {
    var self = this;

    if(self.direction == 0) {

    }

    if(self.direction == 1) {
        self.x += self.bossMoveSpeed;
    }

    if(self.direction == 2) {
        self.x -= self.bossMoveSpeed;
    }

    if(self.direction == 3) {
        self.y += self.bossMoveSpeed;
    }

    if(self.direction == 4) {
        self.y -= self.bossMoveSpeed;
    }

    //if(self.x <= 10 || self.x >= LGlobal.width - 58 || self.y <= 0 || self.y >= LGlobal.height / 3 * 2) {
    //    self.direction = 0;
    //}

    if(self.x > LGlobal.width - 58) {
        self.x = LGlobal.width - 58;
    }

    if(self.x < 10) {
        self.x = 10;
    }

    if(self.y < 10) {
        self.y = 10;
    }

    if(self.y > LGlobal.height / 3) {
        self.y = LGlobal.height / 3;
    }

    if(self.moveCount == 20) {
        self.moveCount = 0;
        self.direction = bossMoveRandom();
    }


    self.moveCount++;
}

function bossMoveRandom() {
    var direction = Math.floor(0 + 5 * Math.random());
    return direction;
}