/**
 * Created by Administrator on 2014/12/12.
 */

function Missile() {
    base(this, LSprite, []);
    var self = this;

    self.bitmapData = new LBitmapData(_imgList["missile"]);
    self.bitmap = new LBitmap(self.bitmapData);

    self.xSpeed = 0;
    self.ySpeed = 0;
    self.targetEnemy = null;

    self.addChild(self.bitmap);
}

Missile.prototype.onframe = function (whichMissile) {
    var self = this;

    //if(_enemy1Arr.length != 0) {
    //    self.targetEnemy = _enemy1Arr[0];
    //    var squareX = (self.targetEnemy.x + 16 - self.x - 10) * (self.targetEnemy.x + 16 - self.x - 10);
    //    var squareY = (self.targetEnemy.y + 24 - self.y - 21) * (self.targetEnemy.y + 24 - self.y - 21);
    //    var radius = Math.sqrt(squareX + squareY);
    //    self.xSpeed = (self.targetEnemy.x - self.x) / radius * 10;
    //    self.ySpeed = (self.targetEnemy.y - self.y) / radius * 10;
    //} else {
    //    self.xSpeed = 0;
    //    self.ySpeed = - 10;
    //    self.bitmap.rotate = 0;
    //    self.targetEnemy = null;
    //}

    if(_enemy1Arr.length != 0 && _enemy2Arr.length != 0 && _enemy3Arr.length != 0) {
        //self.targetEnemy = _enemy1Arr[0];
        if(_enemy1Arr[0].y > _enemy2Arr[0].y) {
            self.targetEnemy = _enemy1Arr[0];
        } else {
            self.targetEnemy = _enemy2Arr[0];
        }
        if(self.targetEnemy.y < _enemy3Arr[0].y) {
            self.targetEnemy = null;
            self.targetEnemy = _enemy3Arr[0];
        }

    } else if(_enemy1Arr.length != 0 && _enemy2Arr.length != 0 && _enemy3Arr.length == 0) {
        if(_enemy1Arr[0].y > _enemy2Arr[0].y) {
            self.targetEnemy = _enemy1Arr[0];
        } else {
            self.targetEnemy = _enemy2Arr[0];
        }

    } else if(_enemy1Arr.length != 0 && _enemy2Arr.length == 0 && _enemy3Arr.length != 0) {
        if(_enemy1Arr[0].y > _enemy3Arr[0].y) {
            self.targetEnemy = _enemy1Arr[0];
        } else {
            self.targetEnemy = _enemy3Arr[0];
        }
    } else if(_enemy1Arr.length == 0 && _enemy2Arr.length != 0 && _enemy3Arr.length != 0) {
        if(_enemy2Arr[0].y > _enemy3Arr[0].y) {
            self.targetEnemy = _enemy2Arr[0];
        } else {
            self.targetEnemy = _enemy3Arr[0];
        }
    } else if(_enemy1Arr.length != 0 && _enemy2Arr.length == 0 && _enemy3Arr.length == 0) {
        self.targetEnemy = _enemy1Arr[0];
    } else if(_enemy1Arr.length == 0 && _enemy2Arr.length != 0 && _enemy3Arr.length == 0) {
        self.targetEnemy = _enemy2Arr[0];
    } else if(_enemy1Arr.length == 0 && _enemy2Arr.length == 0 && _enemy3Arr.length != 0) {
        self.targetEnemy = _enemy3Arr[0];
    } else if(_enemy1Arr.length == 0 && _enemy2Arr.length == 0 && _enemy3Arr.length == 0) {
        self.xSpeed = 0;
        self.ySpeed = - 10;
        self.bitmap.rotate = 0;
        self.targetEnemy = null;
    }

    if(self.targetEnemy != null) {

        var squareX = (self.targetEnemy.x + 16 - self.x - 10) * (self.targetEnemy.x + 16 - self.x - 10);
        var squareY = (self.targetEnemy.y + 24 - self.y - 21) * (self.targetEnemy.y + 24 - self.y - 21);
        var radius = Math.sqrt(squareX + squareY);
        self.xSpeed = (self.targetEnemy.x - self.x) / radius * 10;
        self.ySpeed = (self.targetEnemy.y - self.y) / radius * 10;

        if(self.targetEnemy.x + 16 - self.x - 10 >= 0 && self.targetEnemy.y + 24 - self.y - 21 <= 0) {
            var sin = (self.targetEnemy.x + 16 - self.x - 10) / radius;
            var angel = Math.asin(sin) / Math.PI * 180;
            self.bitmap.rotate = angel;
        }

        if(self.targetEnemy.x + 16 - self.x - 10 < 0 && self.targetEnemy.y + 24 - self.y - 21 <= 0) {
            var sin = (self.targetEnemy.x + 16 - self.x - 10) / radius;
            var angel = Math.asin(sin) / Math.PI * 180;
            self.bitmap.rotate = angel;
        }

        if(self.targetEnemy.x + 16 - self.x - 10 <= 0 && self.targetEnemy.y + 24 - self.y - 21 > 0) {
            var sin = (self.x + 10 - self.targetEnemy.x - 16) / radius;
            var angel = 180 - Math.asin(sin) / Math.PI * 180;
            self.bitmap.rotate = - angel;
        }

        if(self.targetEnemy.x + 16 - self.x - 10 > 0 && self.targetEnemy.y + 24 - self.y - 21 > 0) {
            var sin = (self.targetEnemy.x + 16 - self.x - 10) / radius;
            var angel = 180 - Math.asin(sin) / Math.PI * 180;
            self.bitmap.rotate = angel;
        }
    }


    self.x += self.xSpeed;
    self.y += self.ySpeed;

    if(self.y < 0) {
        _missileLayer.removeChild(self);
        _missileArr.splice(whichMissile, 1);
    }

}