/**
 * Created by Administrator on 2014/12/4.
 */

var _playerAni;
var _playerMoveX;
var _playerMoveY;
var _canShoot = true;
var _canMissile = true;
var _collideX;
var _collideY;
var _list;
var _data;

function Player() {
    base(this, LSprite, []);

    _playerMoveX = 0;
    _playerMoveY = 0;
    var self = this;

    var list = LGlobal.divideCoordinate(128, 48, 1, 4);
    var data = new LBitmapData(_imgList["player"], 0, 0, 32, 48);
    self.animeRun = new LAnimation(self, data, [
        [list[0][0], list[0][1], list[0][2], list[0][3]]
    ]);
    _list = LGlobal.divideCoordinate(128, 70, 1, 4);
    _data = new LBitmapData(_imgList["playerHorse"], 0, 0, 32, 70);
    self.animeRun = new LAnimation(self, data, [
        [list[0][0], list[0][1], list[0][2], list[0][3]]
    ]);
    _playerAni = self.animeRun;
    self.index = 0;
    self.count = 0;
    self.missileCount = 0;
    self.missileInterval = 100;
    self.hp = 3;
    self.canHited = true;
    self.invincibleCount = 0;
    self.interval = 4;
}

Player.prototype.onframe = function() {

    var self = this;

    if(isObstacleExist(_collideX, _collideY) == true) {
        _playerMoveX = 0;
        _playerMoveY = 1;
    }

    _player.x += _playerMoveX;
    _player.y += _playerMoveY;

    if(_player.x < 0) {
        _player.x = 0;
    }

    if(_player.x > LGlobal.width - 32) {
        _player.x = LGlobal.width - 32;
    }

    if(_player.y < 50) {
        _player.y = 50;
    }

    if(_player.y > LGlobal.height - 48) {
        _player.y = LGlobal.height - 48;
    }

    if(_canShoot == true) {

            if(_bulletType == 1) {
                if(_player.count == 3) {
                    _player.shoot();
                    _player.count = 0;
                }
            }

            if(_bulletType == 2) {
                if(_player.count == 15) {
                    _player.shot();
                    _player.count = 0;
                }
            }

        if(_bulletType == 3) {
            if(_player.count == 3) {
                _player.doubleShoot();
                _player.count = 0;
            }
        }

        _player.count++;
    }

    //if(_canMissile == true) {
    //    if(_player.missileCount == _player.missileInterval) {
    //        _player.missile();
    //        _player.missileCount = 0;
    //    }
    //    _player.missileCount++;
    //}

    if(_player.canHited == true) {
        for(var i = 0; i < _enemy1BulletArr.length; i++) {
            if(hitPlayer(_enemy1BulletArr[i], _player)) {
                _enermyBulletLayer.removeChild(_enemy1BulletArr[i]);
                _enemy1BulletArr.splice(i, 1);
                _player.hp --;
                _player.canHited = false;
            }
        }

        for(var i = 0; i < _explodeArr.length; i++) {
            if(hitPlayer(_explodeArr[i], _player)) {
                _background.removeChild(_enemy1BulletArr[i]);
                _explodeArr.splice(i, 1);
                _player.hp --;
                _player.canHited = false;
            }
        }
    }

    if(_player.canHited == false) {
        if(_player.invincibleCount % 2 == 0) {
            self.alpha = 0;
        } else {
            self.alpha = 1;
        }
        if(_player.invincibleCount >= 23) {
            self.invincibleCount = -1;
            self.canHited = true;
            self.alpha = 1;
        }
        _player.invincibleCount++;
    }

    //for(var i = 0; i < _obstacleArr.length; i++) {
    //    collideObstacle(_obstacleArr[i]);
    //}

    var self = this;

    if(self.index == self.interval) {
        self.index = 0;
        _player.animeRun.onframe();
    }
    self.index++;

    if(self.hp <= 0) {
        _shareType = 1;
        _backSound.stop();
        restart();
    }
}

Player.prototype.shoot = function() {
    var bullet = new Bullet();
    bullet.x = _player.x + 11;
    bullet.y = _player.y;

    _bulletArr.push(bullet);
    _bulletLayer.addChild(bullet);
//  _gunWav.play();

}

Player.prototype.shot = function () {

    //for(var i = 0; i < 5; i++) {
    //    var bullet = new ShotBullet();
    //    bullet.x = _player.x + 11;
    //    bullet.y = _player.y;
    //    bullet.shotXSpeed = -14 + 7 * i;
    //    if(i < 3) {
    //        bullet.shotYSpeed = -20 - 2 * i;
    //    } else {
    //        bullet.shotYSpeed = -28 + 2 * i;
    //    }
    //    //bullet.whichType = 1;
    //
    //    _bulletArr.push(bullet);
    //    _bulletLayer.addChild(bullet);
    //}

    var sector = new SectorBullet();
    sector.x = _player.x - 253 / 2 + 16;
    sector.y = _player.y - 181;
    _sectorArr.push(sector);
    _sectorLayer.addChild(sector);
//  _gunWav.play();


}

Player.prototype.doubleShoot = function () {
    var bullet1 = new DoubleBullet();
    bullet1.x = _player.x - 3;
    bullet1.y = _player.y;

    _bulletArr.push(bullet1);
    _bulletLayer.addChild(bullet1);

    var bullet2 = new DoubleBullet();
    bullet2.x = _player.x + 25;
    bullet2.y = _player.y;

    _bulletArr.push(bullet2);
    _bulletLayer.addChild(bullet2);
//  _gunWav.play();

}

Player.prototype.missile = function () {
    var missile = new Missile();
    missile.x = _player.x;
    missile.y = _player.y;

    //_bulletLayer.addChild(missile);
    //_bulletArr.push(missile);
    _missileLayer.addChild(missile);
    _missileArr.push(missile);

}

//function collideObstacle(obstacle) {
//    //if(_playerMoveY < 0 && _player.y <= obstacle.y + obstacle.height &&_player.x > obstacle.x - 32 && _player.x < obstacle.x + obstacle.width) {
//    //    //if(_player.y - 2 <= obstacle.y + obstacle.height) {
//    //        _player.y = obstacle.y + obstacle.height;
//    //        _playerMoveY = 1;
//    //        _isCollide = true;
//    //    //}
//    //}
//    //
//    if(_isMoveTouchDown == false) {
//        if(_player.y - 2 <= obstacle.y + obstacle.height && _player.x > obstacle.x && _player.x < obstacle.x + obstacle.width - 32) {
//            _playerMoveY = 1;
//        }
//    }
//
//    //if(_isCollide == true && (_player.x < obstacle.x - 32 || _player.x > obstacle.x + obstacle.width)) {
//    //    _isCollide = false;
//    //    _playerMoveY = _lastMoveY;
//    //}
//}

function isObstacleExist(moveX, moveY) {

    if(moveX == 0 && moveY == 0) {
        moveY = 4;
    }

        for(var i = 0; i < _obstacleArr.length; i++) {
            var left = _obstacleArr[i].x - 12;
            var right = _obstacleArr[i].x + _obstacleArr[i].width + 12;
            var up = _obstacleArr[i].y - 8;
            var down = _obstacleArr[i].y + _obstacleArr[i].height + 8;
            var centerX = _player.x + 8 + moveX;
            var centerY = _player.y + 8 + moveY;
            if(centerX > left && centerX < right && centerY > up && centerY < down) {
                return true;
            }
        }

    return false;
}

function restart() {
    //_backLayer.die();
    //_backLayer.removeAllChild();
    _isPause = true;

    var bitmapData = new LBitmapData(_imgList["shareBack"]);
    var bitmap = new LBitmap(bitmapData);
    _backLayer.addChild(bitmap);
    bitmap.x = LGlobal.width / 2 - bitmap.width / 2;
    bitmap.y = LGlobal.height / 2 - bitmap.height / 2;

//  if(_shareType == 1) {
//      document.title = "大镖客的赏金达到了$" + _mark ;
//  }
//  if(_shareType == 2) {
//      document.title = "荒野中，大镖客征服了西部";
//  }
    var shareBack = new ShareBack();
    _backLayer.addChild(shareBack);

    var markText = new LTextField();
    markText.text = "你的赏金为$" + _mark;
    markText.color = "#000000";
    markText.size = 22;
    markText.x = LGlobal.width / 2 - markText.getWidth() / 2;
    markText.y = LGlobal.height / 3;
    _backLayer.addChild(markText);

    var restart = new Restart();
    _backLayer.addChild(restart);
//  var share = new Share();
//  _backLayer.addChild(share);
    //main();
}

function Blood() {
    base(this, LSprite, []);
    var self = this;

    self.bitmapData = new LBitmapData(_imgList["blood"]);
    self.bitmap1 = new LBitmap(self.bitmapData);
    self.addChild(self.bitmap1);
    self.bitmap1.x = 0;
    self.bitmap1.y = 0;

    self.bitmap2 = new LBitmap(self.bitmapData);
    self.addChild(self.bitmap2);
    self.bitmap2.x = self.bitmap1.width;
    self.bitmap2.y = 0;

    self.bitmap3 = new LBitmap(self.bitmapData);
    self.addChild(self.bitmap3);
    self.bitmap3.x = self.bitmap1.width * 2;
    self.bitmap3.y = 0;

    self.addChild(self.bitmap1);
    self.addChild(self.bitmap2);
    self.addChild(self.bitmap3);
}

Blood.prototype.onframe = function () {
    var self = this;

    if(_player.hp == 3) {
        self.bitmap1.alpha = 1;
        self.bitmap2.alpha = 1;
        self.bitmap3.alpha = 1;
    }

    if(_player.hp == 2) {
        self.bitmap1.alpha = 1;
        self.bitmap2.alpha = 1;
        self.bitmap3.alpha = 0;
    }

    if(_player.hp == 1) {
        self.bitmap1.alpha = 1;
        self.bitmap2.alpha = 0;
        self.bitmap3.alpha = 0;
    }

    if(_player.hp == 0) {
        self.bitmap1.alpha = 0;
        self.bitmap2.alpha = 0;
        self.bitmap3.alpha = 0;
    }
}