/**
 * Created by Administrator on 2014/12/9.
 */

var _isShootButtonDown = false;
var _shootButtonCenterX;
var _shootButtonCenterY;
var _shootSlideDistance = 60;

function ShootButton() {
    base(this, LSprite, []);

    var self = this;

    self.bitmapData = new LBitmapData(_imgList["moveButton"]);
    self.bitmap = new LBitmap(self.bitmapData);
    self.bitmap.x = LGlobal.width / 8 * 5;
    self.bitmap.y = LGlobal.height / 4 * 3;
    _shootButtonCenterX = self.bitmap.x;
    _shootButtonCenterY = self.bitmap.y;

    self.sliderBitmapData = new LBitmapData(_imgList["slider"]);
    self.sliderBitmap = new LBitmap(self.sliderBitmapData);
    self.sliderBitmap.x = _shootButtonCenterX + self.bitmap.width / 2 - self.sliderBitmap.width / 2;
    self.sliderBitmap.y = _shootButtonCenterY + self.bitmap.height / 2 - self.sliderBitmap.height / 2;

    self.addChild(self.sliderBitmap);
    self.addChild(self.bitmap);
    self.addEventListener(LMouseEvent.MOUSE_DOWN, shootDown);
    self.addEventListener(LMouseEvent.MOUSE_MOVE, shootMove);
    self.addEventListener(LMouseEvent.MOUSE_UP, shootUp);
}

function shootDown(event) {
    var self = this;
    _isShootButtonDown = true;
}

function shootMove(event) {
    var self = _shootButton;

    if(_isShootButtonDown == true) {
        _shootButton.bitmap.x = event.offsetX - _shootButton.bitmap.width / 2;
        //self.bitmap.y = event.offsetY - 25;
    }
    if(_shootButton.bitmap.x < _shootButtonCenterX - _shootSlideDistance) {
        _shootButton.bitmap.x = _shootButtonCenterX - _shootSlideDistance;
    }

    if(_shootButton.bitmap.x > _shootButtonCenterX + _shootSlideDistance) {
        _shootButton.bitmap.x = _shootButtonCenterX + _shootSlideDistance;
    }
    //_testText.text = _shootButton.bitmap.x;
}

function shootUp(event) {
    _isShootButtonDown = false;
    var self = _shootButton;
    //self.bitmap.x = _shootButtonCenterX;
}