/**
 * Created by Administrator on 2014/12/15.
 */

var _storeLeft;

function Store() {
    base(this, LSprite, []);

    var self = this;

    self.bitmapData = new LBitmapData(_imgList["storeBack"]);
    self.bitmap = new LBitmap(self.bitmapData);
    self.bitmap.x = LGlobal.width / 2 - self.bitmap.width / 2;
    self.bitmap.y = LGlobal.height / 2 - self.bitmap.height / 2;
    _storeLeft = LGlobal.width / 2 - self.bitmap.width / 2 + 20;

    self.addChild(self.bitmap);

    self.exit = new StoreExit();
    self.addChild(self.exit);

    self.horse = new StoreHorse();
    self.addChild(self.horse);

    self.revolver = new StoreRevolver();
    self.addChild(self.revolver);

    self.doubleRevolver = new StoreDoubleRevolver();
    self.addChild(self.doubleRevolver);

    self.shotGun = new StoreShotGun();
    self.addChild(self.shotGun);

    self.distance = new StoreShootDistance();
    self.addChild(self.distance);

    self.wanted = new StoreWanted();
    self.addChild(self.wanted);
}

function StoreExit() {
    base(this, LSprite, []);

    var self = this;

    self.textArea = new LTextField();
    self.textArea.text = "退出";
    self.textArea.color = "#ffffff";
    self.textArea.size = 23;
    self.textArea.x = LGlobal.width / 2 - self.textArea.getWidth() / 2;
    self.textArea.y = LGlobal.height / 100 * 75;
    self.addChild(self.textArea);

    self.addEventListener(LMouseEvent.MOUSE_UP, storeUP);
}

function storeUP(event) {
    _backLayer.removeChild(_store);
    _store = null;
    _isPause = false;
    if(_isBuyHorse == true) {
        _isBuyHorse = false;
        _isPause = true;
        _horseAni = new HorseAnime();
        _horseAni.x = _player.x;
        _horseAni.y = LGlobal.height;
        _background.addChild(_horseAni);
    }
}

function StoreHorse() {
    base(this, LSprite, []);

    var self = this;

    self.textArea = new LTextField();
    self.textArea.text = "马";
    self.textArea.color = "#ffffff";
    self.textArea.size = 23;
    self.textArea.x = _storeLeft + 55;
    self.textArea.y = LGlobal.height / 100 * 20;
    self.addChild(self.textArea);

    self.costArea = new LTextField();
    self.costArea.text = "$10000";
    self.costArea.color = "#ffffff";
    self.costArea.size = 23;
    self.costArea.x = LGlobal.width / 2 + 40;
    self.costArea.y = LGlobal.height / 100 * 20;
    self.addChild(self.costArea);

    self.bitmapData = new LBitmapData(_imgList["horse"]);
    self.bitmap = new LBitmap(self.bitmapData);
    self.bitmap.x = _storeLeft;
    self.bitmap.y = LGlobal.height / 100 * 20 + 5;
    self.addChild(self.bitmap);

    self.addEventListener(LMouseEvent.MOUSE_UP, storeHorseUP);
}

function storeHorseUP(event) {
    if(_mark >= 10000 && _moveSpeed != 8) {
        _mark -= 10000;
        _moveSpeed = 8;
        _isBuyHorse = true;
    }

}

function StoreRevolver() {
    base(this, LSprite, []);

    var self = this;

    self.textArea = new LTextField();
    self.textArea.text = "单发左轮";
    self.textArea.color = "#ffffff";
    self.textArea.size = 23;
    self.textArea.x = _storeLeft + 55;
    self.textArea.y = LGlobal.height / 100 * 29;
    self.addChild(self.textArea);

    self.costArea = new LTextField();
    self.costArea.text = "$1500";
    self.costArea.color = "#ffffff";
    self.costArea.size = 23;
    self.costArea.x = LGlobal.width / 2 + 40;
    self.costArea.y = LGlobal.height / 100 * 29;
    self.addChild(self.costArea);

    self.bitmapData = new LBitmapData(_imgList["revolver"]);
    self.bitmap = new LBitmap(self.bitmapData);
    self.bitmap.x = _storeLeft;
    self.bitmap.y = LGlobal.height / 100 * 29;
    self.addChild(self.bitmap);

    self.addEventListener(LMouseEvent.MOUSE_UP, storeRevolverUP);
}

function storeRevolverUP(event) {

    if(_mark >= 1500) {
        _mark -= 1500;
        _player.count = 3;
        _bulletType = 1;
        _bulletLayer.removeAllChild();
        _bulletArr.splice(0);
    }

}

function StoreDoubleRevolver() {
    base(this, LSprite, []);

    var self = this;

    self.textArea = new LTextField();
    self.textArea.text = "双发左轮";
    self.textArea.color = "#ffffff";
    self.textArea.size = 23;
    self.textArea.x = _storeLeft + 55;
    self.textArea.y = LGlobal.height / 100 * 38;
    self.addChild(self.textArea);

    self.costArea = new LTextField();
    self.costArea.text = "$3000";
    self.costArea.color = "#ffffff";
    self.costArea.size = 23;
    self.costArea.x = LGlobal.width / 2 + 40;
    self.costArea.y = LGlobal.height / 100 * 38;
    self.addChild(self.costArea);

    self.bitmapData = new LBitmapData(_imgList["double_revolver"]);
    self.bitmap = new LBitmap(self.bitmapData);
    self.bitmap.x = _storeLeft;
    self.bitmap.y = LGlobal.height / 100 * 38;
    self.addChild(self.bitmap);

    self.addEventListener(LMouseEvent.MOUSE_UP, storeDoubleRevolverUP);
}

function storeDoubleRevolverUP(event) {

    if(_mark >= 3000) {
        _mark -= 3000;
        _player.count = 3;
        _bulletType = 3;
        _bulletLayer.removeAllChild();
        _bulletArr.splice(0);
    }

}

function StoreShotGun() {
    base(this, LSprite, []);

    var self = this;

    self.textArea = new LTextField();
    self.textArea.text = "散弹枪";
    self.textArea.color = "#ffffff";
    self.textArea.size = 23;
    self.textArea.x = _storeLeft + 55;
    self.textArea.y = LGlobal.height / 100 * 47;
    self.addChild(self.textArea);

    self.costArea = new LTextField();
    self.costArea.text = "$5000";
    self.costArea.color = "#ffffff";
    self.costArea.size = 23;
    self.costArea.x = LGlobal.width / 2 + 40;
    self.costArea.y = LGlobal.height / 100 * 47;
    self.addChild(self.costArea);

    self.bitmapData = new LBitmapData(_imgList["shotgun"]);
    self.bitmap = new LBitmap(self.bitmapData);
    self.bitmap.x = _storeLeft;
    self.bitmap.y = LGlobal.height / 100 * 47 + 10;
    self.addChild(self.bitmap);

    self.addEventListener(LMouseEvent.MOUSE_UP, storeShotGunUP);
}

function storeShotGunUP(event) {

    if(_mark >= 5000) {
        _mark -= 5000;
        _player.count = 3;
        _bulletType = 2;
        _bulletLayer.removeAllChild();
        _bulletArr.splice(0);
    }

}

function StoreShootDistance() {
    base(this, LSprite, []);

    var self = this;

    self.textArea = new LTextField();
    self.textArea.text = "增加射程";
    self.textArea.color = "#ffffff";
    self.textArea.size = 23;
    self.textArea.x = _storeLeft + 55;
    self.textArea.y = LGlobal.height / 100 * 56;
    self.addChild(self.textArea);

    self.costArea = new LTextField();
    self.costArea.text = "$500";
    self.costArea.color = "#ffffff";
    self.costArea.size = 23;
    self.costArea.x = LGlobal.width / 2 + 40;
    self.costArea.y = LGlobal.height / 100 * 56;
    self.addChild(self.costArea);

    self.bitmapData = new LBitmapData(_imgList["gun"]);
    self.bitmap = new LBitmap(self.bitmapData);
    self.bitmap.x = _storeLeft;
    self.bitmap.y = LGlobal.height / 100 * 56 + 10;
    self.addChild(self.bitmap);

    self.addEventListener(LMouseEvent.MOUSE_UP, storeShootDistanceUP);
}

function storeShootDistanceUP(event) {

    if(_mark >= 500 && _shootDistance < 18) {
        _mark -= 500;
        _shootDistance += 2;
        if(_shootDistance >= 18) {
            _shootDistance = 18;
        }
    }

}

function StoreWanted() {
    base(this, LSprite, []);

    var self = this;

    self.textArea = new LTextField();
    self.textArea.text = "通缉令";
    self.textArea.color = "#ffffff";
    self.textArea.size = 23;
    self.textArea.x = _storeLeft + 55;
    self.textArea.y = LGlobal.height / 100 * 65;
    self.addChild(self.textArea);

    self.costArea = new LTextField();
    self.costArea.text = "$15000";
    self.costArea.color = "#ffffff";
    self.costArea.size = 23;
    self.costArea.x = LGlobal.width / 2 + 40;
    self.costArea.y = LGlobal.height / 100 * 65;
    self.addChild(self.costArea);

    self.bitmapData = new LBitmapData(_imgList["wanted"]);
    self.bitmap = new LBitmap(self.bitmapData);
    self.bitmap.x = _storeLeft;
    self.bitmap.y = LGlobal.height / 100 * 65 + 3;
    self.addChild(self.bitmap);

    self.addEventListener(LMouseEvent.MOUSE_UP, storeWantedUP);
}

function storeWantedUP(event) {
    if(_mark >= 15000) {
        _mark -= 15000;
        _isInitBoss = true;
    }

}