/**
 * Created by Administrator on 2014/12/12.
 */

function Enemy3() {
    base(this, LSprite, []);

    var self = this;

    //self.bitmapData = new LBitmapData(_imgList["enemy3"]);
    //self.bitmap = new LBitmap(self.bitmapData);
    //self.addChild(self.bitmap);

    var list = LGlobal.divideCoordinate(64, 48, 1, 2)
    var data = new LBitmapData(_imgList["enemy3"], 0, 0, 32, 48);
    self.animeRun = new LAnimation(self, data, [
        [list[0][0]],
        [list[0][1]]
    ]);

    self.count = 0;
    self.shootCount = 0;
    self.shootInterval = 80;
}

Enemy3.prototype.onframe = function (whichEnemy) {
    var self = this;

    if(self.count < 10) {
        self.x += 5;
        self.y -= 6;
        self.animeRun.setAction(0);
    }

    if(self.count < 20 && self.count >= 10) {
        self.x += 5;
        self.y += 6;
    }

    if(self.count < 50 && self.count >= 20) {
        self.animeRun.setAction(1);
        self.y += 1;
        for(var i = 0; i < _bulletArr.length; i++) {

            if(hitEnermy(self, _bulletArr[i])) {
                _bulletLayer.removeChild(_bulletArr[i]);
                _bulletArr.splice(i, 1);
                _enemy3Layer.removeChild(self);
                _enemy3Arr.splice(whichEnemy, 1);
                _mark += 100;
                _killEnemyCount++;
//              _hurtWav2.play();
            }
        }
    }

    if(self.shootCount == self.shootInterval) {
        self.shootCount = 0;
        self.enermyShoot();
    }
    self.shootCount++;
    //
    //for(var i = 0; i < _missileArr.length; i++) {
    //
    //    if(hitEnermy(self, _missileArr[i])) {
    //        //alert("hit");
    //        _missileLayer.removeChild(_missileArr[i]);
    //        _missileArr.splice(i, 1);
    //        _enemy3Layer.removeChild(self);
    //        _enemy3Arr.splice(whichEnemy, 1);
    //    }
    //}

    if(self.count == 40) {
        self.count = 0;
    }

    self.count++;

    if(self.x > LGlobal.width) {
        _enemy3Layer.removeChild(self);
        _enemy3Arr.splice(whichEnemy, 1);
    }

    self.animeRun.onframe();
}

Enemy3.prototype.enermyShoot = function () {

    var self = this;

    if(self.y < _player.y) {
        var bullet = new Bullet();
        bullet.x = self.x + 16;
        bullet.y = self.y + 48;

        var squareX = (bullet.x - _player.x + 16) * (bullet.x - _player.x + 16);
        var squareY = (bullet.y - _player.y + 24) * (bullet.y - _player.y + 24);
        var radius = Math.sqrt(squareX + squareY);
        bullet.enemy1XSpeed = (_player.x - bullet.x + 16) / radius * _enemy1BulletSpeed;
        bullet.enemy1YSpeed = (_player.y - bullet.y + 24) / radius * _enemy1BulletSpeed;

        _enermyBulletLayer.addChild(bullet);
        _enemy1BulletArr.push(bullet);
    }

}