/**
 * Created by Administrator on 2014/12/4.
 */

var _backLayer;
var _loadingLayer;
var _background;
var _moveButton;
var _shootButton;
var _player;
var _bulletLayer;
var _enemyLayer;
var _enemy1Layer;
var _enemy2Layer;
var _enemy3Layer;

var _enermyBulletLayer;
var _missileLayer;
var _bulletSpeed = 6;
var _initBossCount = 0;
var _enemy1Arr;
var _enemy2Arr;
var _enemy3Arr;
var _missileArr;
var _sectorArr;
var _sectorLayer;
var _thingManager;
var _obstacleManager;
var _enemyManager;
var _shootDistance = 10;

var _isInitBoss = false;
var _boss1;
var _blood;
var _judgeInitBoss = true;
var _judgeInitEnemy2;
var _judgeInitEnemy3;

var _isPause = false;
var _mark = 0;
var _markText;
var _killEnemyCount;

var _testText;
var _backSound;


var _imgList = {};

var _imgData = new Array(
    {name: "map1", path: "./img/map1.png"},
    {name: "moveButton", path: "./img/move_button.png"},
    {name: "bullet", path: "./img/bullet1.png"},
    {name: "player", path: "./img/player.png"},
    {name: "moveBorder", path: "./img/border.png"},
    {name: "enermy1", path: "./img/enermy1.png"},
    {name: "slider", path: "./img/slider.png"},
    {name: "horse", path: "./img/horse.png"},
    {name: "gun", path: "./img/gun.png"},
    {name: "bomb", path: "./img/bomb.png"},
    {name: "enemy2", path: "./img/enemy2.png"},
    {name: "cactus", path: "./img/cactus.png"},
    {name: "explode", path: "./img/explode.png"},
    {name: "enemy3", path: "./img/enemy3.png"},
    {name: "missile", path: "./img/missile.png"},
    {name: "revolver", path: "./img/revolver.png"},
    {name: "double_revolver", path: "./img/double_revolver.png"},
    {name: "shotgun", path: "./img/shotgun.png"},
    {name: "boss1", path: "./img/boss1.png"},
    {name: "store", path: "./img/store.png"},
    {name: "storeBack", path: "./img/store_back.png"},
    {name: "barrel", path: "./img/barrel.png"},
    {name: "wanted", path: "./img/wanted.png"},
    {name: "sector", path: "./img/sector.png"},
    {name: "blood", path: "./img/blood.png"},
    {name: "horseAni", path: "./img/horse_anime.png"},
    {name: "money", path: "./img/money.png"},
    {name: "stone", path: "./img/stone.png"},
    {name: "playerHorse", path: "./img/player_horse.png"},
    {name: "spark", path: "./img/spark.png"},
    {name: "logo", path: "./img/logo.jpg"},
    {name: "stone2", path: "./img/stone2.png"},
    {name: "head", path: "./img/head.png"},
    {name: "shareBack", path: "./img/share_back.png"},
    {name: "share", path: "./img/share.png"},
    {name: "backSound", path: "./sound/back.mp3"}
);

init(50, "gunsmoke", 480, 720, main);

function main() {
    LGlobal.stageScale = LStageScaleMode.EXACT_FIT;
    LSystem.screen(LStage.FULL_SCREEN);
    LMultitouch.inputMode = LMultitouchInputMode.TOUCH_POINT;
    _enemy1Arr = [];
    _backLayer = new LSprite();
    _backLayer.graphics.drawRect(1, "#000000", [0, 0, 480, 720], true, "#000000");
    addChild(_backLayer);

    _loadingLayer = new LoadingSample2(50);
    _backLayer.addChild(_loadingLayer);

    LLoadManage.load(
        _imgData,
        function (progress) {
            _loadingLayer.setProgress(progress);
        },
        gameInit
    );
}

function gameInit(result) {


    _imgList = result;
    _backLayer.removeChild(_loadingLayer);
    _loadingLayer = null;



    var bitmapData = new LBitmapData(_imgList["head"]);
    var bitmap = new LBitmap(bitmapData);
    bitmap.x = LGlobal.width / 2 - bitmap.width / 2;
    bitmap.y = LGlobal.height / 4
    _backLayer.addChild(bitmap);

    var title = new LTextField();
    title.text = "荒野大镖客";
    title.size = 30;
    title.color= "#ffffff";
    title.x = (LGlobal.width - title.getWidth()) / 2;
    title.y = LGlobal.height / 10;
    _backLayer.addChild(title);

    var textClick = new LTextField();
    textClick.text = "点击进入游戏";
    textClick.size = 18;
    textClick.color = "#ffffff";
    textClick.x = (LGlobal.width - textClick.getWidth()) / 2;
    textClick.y = LGlobal.height / 4 * 3;
    _backLayer.addChild(textClick);
    
    var qTitle = new LTextField();
    qTitle.text = "天辰大叔Q群";
    qTitle.size = 14;
    qTitle.color = "#ffffff";
    qTitle.x = LGlobal.width / 100 * 65;
    qTitle.y = LGlobal.height / 100 * 85;
    _backLayer.addChild(qTitle);
    
    var qText = new LTextField();
    qText.text = "179778586";
    qText.size = 14;
    qText.color = "#ffffff";
    qText.x = LGlobal.width / 100 * 65;
    qText.y = LGlobal.height / 100 * 90;
    _backLayer.addChild(qText);


    _backLayer.addEventListener(LMouseEvent.MOUSE_UP, gameStart);
	_backLayer.addEventListener(LEvent.ENTER_FRAME, indexFrame);
	setTimeout(function(){
		_backLayer.removeEventListener();
	},500);
}

function indexFrame() {
	LGlobal.stageScale = LStageScaleMode.EXACT_FIT;
    LSystem.screen(LStage.FULL_SCREEN);
}

function gameStart() {

    _enemy1Arr = new Array();
    _enemy2Arr = new Array();
    _enemy3Arr = new Array();
    _missileArr = new Array();
    _thingArr = new Array();
    _bulletArr = new Array();
    _enemy1BulletArr = new Array();
    _explodeArr = new Array();
    _obstacleArr = new Array();
    _sectorArr = new Array();
    _noCollideObstacleArr = new Array();

    _horseAni = null;
    _initEnemyLevel = 1;
    _killEnemyCount = 0;
    _mark = 0;
    _boss1 = null;
    _bulletType = 1;
    _judgeInitEnemy2 = true;
    _judgeInitEnemy3 = true;

    _backLayer.die();
    _backLayer.removeAllChild();

    _background = new Background();
    _backLayer.addChild(_background);

    _obstacleManager = new ObstacleManager();
    _backLayer.addChild(_obstacleManager);

    _thingManager = new ThingManager();
    _backLayer.addChild(_thingManager);

    _player = new Player();
    _backLayer.addChild(_player);
    _player.x = LGlobal.width / 2;
    _player.y = LGlobal.height / 2;

    _enemyLayer = new LSprite();
    _backLayer.addChild(_enemyLayer);

    _enemy1Layer = new LSprite();
    _backLayer.addChild(_enemy1Layer);

    _enemy2Layer = new LSprite();
    _backLayer.addChild(_enemy2Layer);

    _enemy3Layer = new LSprite();
    _backLayer.addChild(_enemy3Layer);



    _enemyManager = new EnemyManager();
    _backLayer.addChild(_enemyManager);

    //_missileLayer = new LSprite();
    //_backLayer.addChild(_missileLayer);

    _bulletLayer = new LSprite();
    _backLayer.addChild(_bulletLayer);

    _sectorLayer = new LSprite();
    _backLayer.addChild(_sectorLayer);

    _enermyBulletLayer = new LSprite();
    _backLayer.addChild(_enermyBulletLayer);

    _moveButton = new MoveButton();
    _backLayer.addChild(_moveButton);

    _shootButton = new ShootButton();
    _backLayer.addChild(_shootButton);

    _backLayer.addEventListener(LEvent.ENTER_FRAME, onframe);

    _markText = new LTextField;
    _markText.text = "$" + _mark;
    _backLayer.addChild(_markText);
    _markText.x = LGlobal.width / 2 - _markText.getWidth() / 2;
    _markText.color = "#ffffff";
    _markText.size = 20;

    _blood = new Blood();
    _backLayer.addChild(_blood);
    
    _backSound = new LSound();
    _backSound.load(_imgList["backSound"]);
    _backSound.play(0, 10000);

}

function onframe() {
    //_testText.text = _killEnemyCount + "++++" + _initEnemyCount;
    _markText.text = "$" + _mark;
    _blood.onframe();
    //if(_mark >= 200 && _judgeInitBoss == true) {
    //    _isInitBoss = true;
    //    _judgeInitBoss = false;
    //}

    if(_killEnemyCount >= 20 && _killEnemyCount < 50 && _judgeInitEnemy2 == true) {
        _judgeInitEnemy2 = false;
        _initEnemyLevel = 2;
        _initEnemyInterval = 70;
        _initEnemyCount = 0;
    }

    if(_killEnemyCount >= 50 && _judgeInitEnemy3 == true) {
        _judgeInitEnemy3 = false;
        _initEnemyLevel = 3;
        _initEnemyInterval = 60;
        _initEnemyCount = 0;
    }

    if(_horseAni != null) {
        _horseAni.onframe();
    }

    if(_isPause == false) {
        _background.onframe();
        _player.onframe();
        _thingManager.onframe();
        _obstacleManager.onframe();
        _enemyManager.onframe();

        _initEnemyCount++;

        if(_isInitBoss == true && _initBossCount == 500) {
            _isInitBoss = false;
            _initBossCount = 0;
            _boss1 = new Boss1();
            _boss1.x = 240;
            _boss1.y = - 48;
            _backLayer.addChild(_boss1);

        }
        if(_boss1 != null) {
            _boss1.onframe();
        }

        if(_isInitBoss == true) {
            _initBossCount++;
        }

        for(var i = 0; i < _enemy1Arr.length; i++) {
            _enemy1Arr[i].onframe(i);
        }

        for(var i = 0; i < _enemy2Arr.length; i++) {
            _enemy2Arr[i].onframe(i);
        }

        for(var i = 0; i < _enemy3Arr.length; i++) {
            _enemy3Arr[i].onframe(i);
        }

        for(var i = 0; i < _explodeArr.length; i++) {
            _explodeArr[i].onframe(i);
        }

        for(var i = 0; i < _sectorArr.length; i++) {
            _sectorArr[i].onframe(i);
        }

        if(_bulletType == 1) {
            for(var i = 0; i < _bulletArr.length; i++) {
                _bulletArr[i].x -= 3 * _bulletSpeed * (_shootButtonCenterX - _shootButton.bitmap.x) / _shootSlideDistance;
                _bulletArr[i].y -= 4 * _bulletSpeed;

                _bulletArr[i].shootCount++;
                if(_bulletArr[i].shootCount == _shootDistance) {
                    _bulletLayer.removeChild(_bulletArr[i]);
                    _bulletArr.splice(i, 1);
                }

                if(_bulletArr[i].y < - 20) {
                    _bulletLayer.removeChild(_bulletArr[i]);
                    _bulletArr.splice(i, 1);
                }

            }
        }

        if(_bulletType == 2) {
            for(var i = 0; i < _bulletArr.length; i++) {
                _bulletArr[i].onframe(i);
            }
        }

        if(_bulletType == 3) {
            for(var i = 0; i < _bulletArr.length; i++) {
                _bulletArr[i].onframe(i);
            }
        }



        for(var i = 0; i < _missileArr.length; i++) {
            _missileArr[i].onframe(i);
        }

        for(var i = 0; i < _enemy1BulletArr.length; i++) {
            _enemy1BulletArr[i].onframe(i);
        }

    }
}

function hitEnermy(bullet, enemy) {
    if(bullet.x - 5 < enemy.x && bullet.x - 5 > (enemy.x - 32 + 10) && bullet.y - 5 < enemy.y && bullet.y - 5 > (enemy.y - 48 + 10)) {
        return true;
    } else {
        return false;
    }
}

function hitPlayer(bullet, player) {
    if(bullet.x > player.x && bullet.x < player.x + 32 - 10 && bullet.y > player.y && bullet.y < player.y + 48 - 10) {
        return true;
    } else {
        return false;
    }
}
